/**
 * @file FootyLine.cpp
 * @brief CFootyLine̎s܂B
 * @author Shinji Watanabe
 * @date Oct.30.2008
 */

#include "FootyLine.h"

//-----------------------------------------------------------------------------
/**
 * @brief RXgN^łBŏ̍s\z܂B
 */
CFootyLine::CFootyLine()
{
	m_nEthicLine = 1;
	m_nLineOffset = 0;
	m_nRealLineNum = 0;
	m_bEmphasisChached = false;
	m_nLineIcons = 0;
}

//-----------------------------------------------------------------------------
/**
 * @brief O̍s̃ItZbglƗϗsɂ̃ItZbglݒ肵܂B
 * @param pPrevLine O̍sւ̃Ce[^
 * @return OƕςĂtrueԂ
 */
bool CFootyLine::SetPrevLineInfo(LinePt pPrevLine)
{
	// obNAbv
	size_t nOffsetBefore = m_nLineOffset;
	size_t nRealBefore = m_nRealLineNum;

	// sԍf[^vZ
	m_nLineOffset = pPrevLine->m_nLineOffset + pPrevLine->m_nEthicLine;
	m_nRealLineNum = pPrevLine->m_nRealLineNum + 1;

	// Ôƈꏏǂ`FbN
	return  m_nLineOffset != nOffsetBefore || m_nRealLineNum != nRealBefore;
}

//-----------------------------------------------------------------------------
/**
 * @brief s̃f[^tbVĊevZs܂B
 * @param nTabLen ^u
 * @param nColumn ܂Ԃ
 * @param nMode ܂Ԃ[h
 * @return _sύXꂽꍇtrueԂ
 * @note f[^ύXŌɂ̏ĂяoKv܂B
 */
bool CFootyLine::FlushString(size_t nTabLen,size_t nColumn,int nMode)
{
	// 錾
	CUrlInfo stInsert;

	// _s̏XV
	size_t nBeforeEthicLine = m_nEthicLine;
	m_nEthicLine = CalcEthicLine(GetLineLength(),nColumn,nTabLen,nMode).m_nEthicLine + 1;

	// NbJuURĽ
	stInsert.m_nEndPos = -1;
	m_vecUrlInfo.clear();
	forever{
		if (!FindURL(stInsert.m_nEndPos + 1,
			&stInsert.m_nStartPos,&stInsert.m_nEndPos))break;
		m_vecUrlInfo.push_back(stInsert);
	}

	// NbJu[AhX̌
	stInsert.m_nEndPos = -1;
	m_vecMailInfo.clear();
	forever{
		if (!FindMail(stInsert.m_nEndPos + 1,
			&stInsert.m_nStartPos,&stInsert.m_nEndPos))break;
		m_vecMailInfo.push_back(stInsert);
	}
	return m_nEthicLine != nBeforeEthicLine;
}


//-----------------------------------------------------------------------------
/**
 * @brief nPos̈ʒuǂӂɂ邩vZ郋[`łB
 */
CFootyLine::EthicInfo CFootyLine::CalcEthicLine(size_t nPos,size_t nColumn,size_t nTab,int nMode) const
{
	// 錾
	const wchar_t *pWork = GetLineData();
	EthicInfo stRet;
	// 
	stRet.m_nEthicLine = 0;
	stRet.m_nEthicColumn = 0;
	// 񑖍
	for (size_t i=0;i<nPos;i++,pWork++)
	{
		// ^u
		if (*pWork == L'\t')
		{
			for (stRet.m_nEthicColumn++;;stRet.m_nEthicColumn++)
			{
				if (stRet.m_nEthicColumn % nTab == 0)break;
			}
		}
		else
		{
			// {ǂ肷
			bool bIsDualWidth = false;
			if (IsSurrogateLead(*pWork))	// TQ[gyÂPoCg
			{
				bIsDualWidth = IsDualChar(*pWork,*(pWork+1));
				pWork++;i++;
			}
			else							// TQ[gyAł͂ȂƂ
			{
				bIsDualWidth = IsDualChar(*pWork);
			}
			// ʒu炷
			if (bIsDualWidth)stRet.m_nEthicColumn += 2;
			else stRet.m_nEthicColumn ++;
		}
		// ̕֍s܂H
		if (IsGoNext(pWork,i,stRet.m_nEthicColumn,nColumn,nMode))
		{
			stRet.m_nEthicColumn = 0;
			stRet.m_nEthicLine ++ ;
		}
	}
	// lԂ
	return stRet;
}

//-----------------------------------------------------------------------------
/**
 * @brief ϗsۂ̌vZ郋[`łB
 * @note nEthicLinenEthicPos0x[Xœn܂B
 */
size_t CFootyLine::CalcRealPosition(size_t nEthicLine,size_t nEthicPos, size_t nColumn,size_t nTab,int nMode) const
{
	// 錾
	const wchar_t *pWork = GetLineData();
	size_t nLineLength = GetLineLength();
	size_t nVisPosition = 0;
	size_t nNowEthic = 0;
	size_t i;
	// 񑖍
	for (i=0;i<nLineLength;i++,pWork++)
	{
		// K邩(IH)
		if (nNowEthic == nEthicLine)
		{
			if (nVisPosition >= nEthicPos)break;
		}
		// ^u
		if (*pWork == L'\t')
		{
			for (nVisPosition++;;nVisPosition++)
			{
				if (nVisPosition % nTab == 0)break;
			}
		}
		else
		{
			// {ǂ肷
			bool bIsDualWidth = false;
			if (IsSurrogateLead(*pWork))	// TQ[gyÂPoCg
			{
				bIsDualWidth = IsDualChar(*pWork,*(pWork+1));
				pWork++;i++;
			}
			else							// TQ[gyAł͂ȂƂ
			{
				bIsDualWidth = IsDualChar(*pWork);
			}
			// ʒu炷
			if (bIsDualWidth)nVisPosition += 2;
			else nVisPosition ++;
		}
		// ̍s֍s܂H
		if (IsGoNext(pWork,i,nVisPosition,nColumn,nMode))
		{
			nVisPosition = 0;
			nNowEthic ++ ;
		}
	}
	// lԂ
	return i;
}

//-----------------------------------------------------------------------------
/**
 * @brief s̍ŏw肳ꂽʒu܂ł̋󔒐vZ
 * @param	nPos	[in] vZʒu
 * @return 
 */
size_t CFootyLine::CalcAutoIndentPos( size_t nPos ) const
{
	size_t i = 0;
	for ( i = 0; i < nPos; i++ )
	{
		wchar_t c = m_strLineData[ i ];
		if ( c != '\t' && c != ' ' )
		{
			break;
		}
	}
	return i;
}

/*[EOF]*/
